<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_CLASS_BOXFUNCTIONS_INCLUDED') ) {
	define ('_OPN_CLASS_BOXFUNCTIONS_INCLUDED', 1);

	include_once (_OPN_ROOT_PATH . 'modules/mediagallery/include/class.filefunctions.php');
	include_once (_OPN_ROOT_PATH . 'modules/mediagallery/include/class.mediafunctions.php');
	include_once (_OPN_ROOT_PATH . 'modules/mediagallery/include/class.album.functions.php');
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.functions.php');

	class BoxFunctions {

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_options = array();

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_fields = array ('pid', 'filename', 'title', 'description', 'aid');

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_pic = array();

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_album;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_categorie;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_filefunction;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_mediafunction;

		/**
		 * Class constructor
		 * 		
		 * @param $options
		 */
		function /*<{4php5}>AlbumFunctions!!__construct<{4php5/}>*//*<{delete}>*/BoxFunctions/*<{delete/}>*/ ($options) {

			global $opnConfig, $opnTables;

			$this->_options = $options;
			$checkerlist = $opnConfig['permission']->GetUserGroups ();
			$this->_categorie =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ CatFunctions ('mediagallery');
			$this->_categorie->itemtable = $opnTables['mediagallery_albums'];
			$this->_categorie->itemid = 'aid';
			$this->_categorie->itemlink = 'cid';
			$this->_categorie->itemwhere = 'i.usergroup IN (' . $checkerlist . ')';
			if ( (isset ($opnConfig['opnOption']['themegroup']) ) && ($opnConfig['opnOption']['themegroup'] >= 1) ) {
				$this->_categorie->itemwhere .= " AND ((i.themegroup='" . $opnConfig['opnOption']['themegroup'] . "') OR (i.themegroup=0))";
			}
			$this->_album =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ AlbumFunctions ();
			$this->_mediafunction =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ MediaFunctions ();
			$this->_filefunction =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ FileFunctions;

		}

		/**
		 * Get the boxstuffcontent
		 * 
		 * @return string
		 */
		function GetContent () {

			$data = '';
			switch ($this->_options['smidtype']) {
				case 1:
					$data = $this->_get_newest ();
					break;
				case 2:
					$data = $this->_get_static ();
					break;
				case 3:
				case 7:
					$data = $this->_get_random ();
					break;
				case 4:
					$data = $this->_get_best_media ('rated');
					break;
				case 5:
					$data = $this->_get_best_media ('hits');
					break;
				case 6:
					$data = $this->_get_newest_comment ();
					break;
			} /* switch */

			return $data;
		}

		// private functions

		/**
		 * Builds the where statement
		 * 		
		 * @param $where
		 */		
		function _build_where (&$where) {

			$aids = $this->_categorie->GetCatList ();
			if ($aids != '') {
				$where = 'i.aid IN (' . $this->_album->GetAlbumListAll ($aids) . ')';
			} else {
				$where = 'i.aid=0';
			}
			$where .= ' AND i.approved = 1';
			unset($aids);

		}

		/**
		 * Checks if the media is a pic
		 * 		
		 * @param $pic
		 * @return boolean
		 */
		function _check_if_pic ($pic) {

			$isimage = true;
			if ($this->_options['onlyimages'] == 1) {
				if (!$this->_mediafunction->is_convertable ($pic['filename'], true)) {
					$isimage = false;
				}
			}
			return $isimage;
		}

		/**
		 * Render the box content
		 * 		
		 * @return string
		 */
		function _render_box () {

			global $opnConfig;

			$content = '';
			$css = 'opn' . $this->_options['opnbox_class'] . 'box';
			$thumb = _THUMB_CENTERBOX;
			$width = $opnConfig['mediagallery_centerbox_width'] + 38;
			$height = $opnConfig['mediagallery_centerbox_height'] + 2;
			$iwidth = $opnConfig['mediagallery_centerbox_width'];
			$iheight = $opnConfig['mediagallery_centerbox_height'];
			$horizontal = false;
			if ($this->_options['opnbox_class'] == 'side') {
				$width = $opnConfig['mediagallery_sidebox_width'] + 38;
				$height = $opnConfig['mediagallery_sidebox_height'] + 2;
				$iwidth = $opnConfig['mediagallery_sidebox_width'];
				$iheight = $opnConfig['mediagallery_sidebox_height'];
				$thumb = _THUMB_SIDEBOX;
			} else if ($this->_options['horizontal']) {
				$horizontal = true;
			}
			$url = array();
			$url[0] = $opnConfig['opn_url'] . '/modules/mediagallery/index.php';
			$url['op'] = 'viewmedia';
			if ((count ($this->_pic)) && ($horizontal)) {
				$content .= '<ul class="polahori">';
			}
			foreach ($this->_pic as $pic) {
				if ($horizontal) {
					$content .= '<li>';
				}
				$url['offset'] =  - $pic['pid'];
				if ($pic['orderby'] != '') {
					$url['orderby'] = $pic['orderby'];
				}
				if (isset ($pic['op'])) {
					$url['op1'] = $pic['op'];
				}
				if ($pic['title'] == '') {
					$pic['title'] = '---';
				}
				if (isset ($this->_options['doalbum'])) {
					if ($this->_options['doalbum']) {
						$url['aid'] = $pic['aid'];
					}
				}
				if ($this->_mediafunction->is_convertable ($pic['filename'], true)) {
					$image = $this->_filefunction->GetThumbnailName ($pic['filename'], $pic['pid'], _PATH_MEDIA, $thumb, true);
				} else {
					$image = $opnConfig['datasave']['mediagallery_images']['url'] . '/filetypes/' . $this->_mediafunction->GetDocumentIcon ($pic['filename']);
				}
				if ($this->_options['usepolaroid']) {
					$content .= '<div class="pola" style="width:' . $width .'px;"><div class="polahead"><div class="polatopleft"></div><div class="polatopright"></div></div>';
					$content .= '<div class="polaleftborder" style="height:' . $height. 'px;"><div class="polarightborder"></div>';
				} else {
					$content .= '<div style="width:' . $width .'px;" align="center">';
				}
				$content .= '<a class="' . $css .'" href="' . encodeurl ($url) . '">';
				if ($pic['description'] != '') {
					$title = 'title="' . str_replace ('"', '', $pic['description']) . '" ';
				} else {
					$title = '';
				}
				if ($this->_options['usepolaroid']) {
					$content .= '<img src="' . $opnConfig['defimages']->GetImageUrl ('trans') . '" class="polaimg" alt="' . $pic['filename'] . '" ' . $title . ' width="' . $iwidth . '" height="' . $iheight . '" style="background: url(' . $image . ') no-repeat center;" />';
				} else {
					$content .= '<img src="' . $image . '" alt="' . $pic['filename'] . '" ' . $title . '/>';
				}
				$content .= '</a></div>';
				if ($this->_options['hidename'] == 0) {
					if ($this->_options['usepolaroid']) {
						$content .= '<div class="polatext"><div class="polatextright"></div>';
					} else {
						$content .= '<div style="width:' . $width .'px;" align="center">';
					}
					$content .= '<a class="' . $css .'" href="' . encodeurl ($url ) . '">' . $pic['title'] . '</a></div>';
				}
				if ($this->_options['usepolaroid']) {
					$content .= '<div class="polabottom"><div class="polabottomleft"></div><div class="polabottomright"></div></div></div>';
				}
				if ($horizontal) {
					$content .= '</li>';
				} elseif (!$this->_options['usepolaroid']) {
					$content .= '<br />';
				}
			}
			if ((count ($this->_pic)) && ($horizontal)) {
				$content .= '</ul>';
			}
			unset($url);
			$this->_pic = array();
			return $content;
		}

		/**
		 * Get the newest media
		 * 		
		 * @return string
		 */
		function _get_newest () {

			$where = '';
			$this->_build_where ($where);
			$swhere = $where;
			$isdone = 0;
			$ids = array();
			do {
				$isdone = 0;
				$this->_pic = array();
				$counter = $this->_album->GetItemCount ($where);
				$limit = min ($this->_options['newestnumber'], $counter);
				$result = $this->_album->GetItemLimit ($this->_fields, array ('i.ctime DESC'), $limit, $where);
				if ($result->EOF) {
					$result->Close ();
					break;
				}
				$item = 0;
				$this->_get_data ($result, $item, $ids, $isdone, '', 'cd');
				if ($isdone != 0) {
					$where = $swhere . ' AND i.pid NOT IN (' . implode (',', $ids) . ')';
				}
				$result->Close ();
			} while ($isdone > 0);
			return $this->_render_box ();
		}

		/**
		 * Get a static media
		 * 		
		 * @return string
		 */
		function _get_static () {

			$where = '';
			$this->_build_where ($where);
			$ids = array();
			if (substr_count ($this->_options['staticnumber'], ',') > 0) {
				$where .= ' AND i.pid IN (' . $this->_options['staticnumber'] . ')';
			} else {
				$where .= ' AND i.pid=' . $this->_options['staticnumber'];
			}
			$this->_pic = array();
			$result = $this->_album->GetItemResult ($this->_fields, array (), $where);
			$item = 0;
			$isdone = 0;
			$this->_get_data ($result, $item, $ids, $isdone);
			$result->Close ();
			return $this->_render_box ();
		}

		/**
		 * Getb a random media
		 * 		
		 * @return string
		 */
		function _get_random () {

			$this->_options['doalbum'] = false;
			$where = '';
			$this->_build_where ($where);
			if ($this->_options['smidtype'] == 7) {
				if (is_array ($this->_options['smidtype7categories'])) {
					$this->_options['doalbum'] = true;
					$where .= ' AND (';
					$max = count ($this->_options['smidtype7categories']);
					for ($i = 0; $i < $max; $i++) {
						$where .= 'i.aid=' . $this->_options['smidtype7categories'][$i];
						if ($i < $max -1) {
							$where .= ' OR ';
						}
					}
					$where .= ')';

				}
			}
			$swhere = $where;
			$isdone = 0;
			$ids = array();
			do {
				$isdone = 0;
				$this->_pic = array();
				$counter = $this->_album->GetItemCount ($where);
				if ($counter > 0) {
					$range = range (0, $counter - 1);
					$offset = array_rand ($range);
					$limit = min ($this->_options['newestnumber'], $counter);
					$offsets = array_rand ($range, $limit);
					unset($range);
					$item = 0;
					if (!is_array ($offsets)) {
						$off = array ();
						$off[] = $offset;
						$offsets = $off;
						unset($off);
					}
					foreach ($offsets as $offset) {
						$result = $this->_album->GetItemLimit ($this->_fields, array (), 1, $where, $offset);
						if ($result->EOF) {
							$result->Close ();
							break 2;
						}
						$this->_get_data ($result, $item, $ids, $isdone);
						if ($isdone != 0) {
							$where = $swhere . ' AND i.pid NOT IN (' . implode (',', $ids) . ')';
						}
						$result->Close ();
					}
				}
			} while ($isdone > 0);
			return $this->_render_box ();
		}

		/**
		 * Get the best rated or most viewed media
		 * 		
		 * @return string
		 */
		function _get_best_media ($which) {

			global $opnConfig;

			$where = '';
			$this->_build_where ($where);
			if ($which == 'rated') {
				$where .= ' AND i.votes>=' . $opnConfig['mediagallery_min_votes'];
				$orderby = array('i.rating DESC');
				$orderby1 = 'rd';
				$op = 'toprated';
			} else {
				$where .= ' AND i.hits>0';
				$orderby = array('i.hits DESC');
				$orderby1 = 'hd';
				$op = 'mostviewed';
			}
			$swhere = $where;
			$isdone = 0;
			$ids = array();
			do {
				$isdone = 0;
				$counter = $this->_album->GetItemCount ($where);
				$limit = min ($this->_options['newestnumber'], $counter);
				$this->_pic = array();
				$result = $this->_album->GetItemLimit ($this->_fields, $orderby, $limit, $where);
				if ($result->EOF) {
					$result->Close ();
					break;
				}
				$item = 0;
				$this->_get_data ($result, $item, $ids, $isdone, $op, $orderby1);
				if ($isdone != 0) {
					$where = $swhere . ' AND i.pid NOT IN (' . implode (',', $ids) . ')';
				}
				$result->Close ();
			} while ($isdone > 0);
			return $this->_render_box ();
		}

		/**
		 * Get the newest mediacomment
		 * 		
		 * @return string
		 */
		function _get_newest_comment () {

			global $opnConfig, $opnTables;

			$where = '';
			$this->_build_where ($where);
			$swhere = $where;
			$cwhere = '';
			$isdone = 0;
			$ids = array();
			do {
				$isdone = 0;
				$this->_pic = array();
				$limit = $this->_options['newestnumber'];
				$result = $opnConfig['database']->SelectLimit ('SELECT DISTINCT sid FROM ' . $opnTables['mediagallery_comments'] . $cwhere . ' ORDER BY wdate DESC', $limit);
				if ($result->EOF) {
					$result->Close ();
					break;
				}
				$item = 0;
				while (!$result->EOF) {
					$sid = $result->fields['sid'];
					$where = $swhere . ' AND i.pid=' . $sid;
					$counter = $this->_album->GetItemCount ($where);
					$limit = min ($this->_options['newestnumber'], $counter);
					$result1 = $this->_album->GetItemLimit ($this->_fields, array (), 1, $where);
					if ($result1->EOF) {
						$ids[] = $sid;
						$isdone = 1;
					}
					$this->_get_data ($result1, $item, $ids, $isdone);
					if ($isdone != 0) {
						$cwhere = ' WHERE sid NOT IN (' . implode (',', $ids) . ')';
						break;
					}
					$result1->Close ();
					$result->MoveNext();
				}
				$result->Close ();
			} while ($isdone > 0);
			return $this->_render_box ();
		}

		/**
		 * Retrieves the mediadata
		 * 		
		 * @param $result
		 * @param $item
		 * @param $ids
		 * @param $isdone
		 * @param $op
		 * @param $orderby
		 */
		function _get_data (&$result, &$item, &$ids, $isdone, $op = '', $orderby = '') {

			while (!$result->EOF) {
				$pic = $result->GetRowAssoc ('0');
				if ($this->_check_if_pic ($pic)) {
					$this->_pic[$item] = $pic;
					$this->_pic[$item]['orderby'] = $orderby;
					if ($op != '') {
						$this->_pic[$item]['op'] = $op;
					}
					$item++;
				} else {
					$ids[] = $pic['pid'];
					$isdone = 1;
				}
				$result->MoveNext ();
			}

		}
	}
}

?>