<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_IMAGEOBJECT_IM_INCLUDED') ) {
	define ('_OPN_CLASS_IMAGEOBJECT_IM_INCLUDED', 1);

	class imageobject_im extends imageobject {

		/**
		 * Class constructor
		 * 
		 * @param $directory
		 * @param $filename
		 */
		function /*<{4php5}>imageobject_im!!__construct<{4php5/}>*//*<{delete}>*/imageobject_im/*<{delete/}>*/ ($directory, $filename) {

			$this->PerformParams ($directory, $filename);
		}

		/**
		 * Set's the needed params
		 * 
		 * @param string $directory
		 * @param string $filename
		 */
		function PerformParams ($directory, $filename) {

			$this->SetParams ($directory, $filename);
			$this->_truecolor = true;
			if (file_exists ($directory . $filename) ) {
				$this->_filesize = round (filesize ($this->_fullname)/1000);
				if ($this->_filesize>0) {
					$size = $this->GetImageInfo ($this->_fullname);
					if ($size) {
						$this->_imgRes = true;
					}
					$this->_width = $size[0];
					$this->_height = $size[1];
					$this->_string = $size[3];
				}
			}
			// if
		}

		/**
		* Crop an image
		*
		* @param $clipval
		*/

		function cropImage (&$clipval) {

			global $opnConfig;

			$cliparray = split (",", $clipval);
			$clip_top = $cliparray[0];
			$clip_right = $cliparray[1];
			$clip_bottom = $cliparray[2];
			$clip_left = $cliparray[3];
			$new_w = $clip_right- $clip_left;
			$new_h = $clip_bottom- $clip_top;
			$imgFile = $this->_escapedname;
			$output = array ();
			$retval = 0;
			$OS='';
			get_var ('OS',$OS,'env',_OOBJ_DTYPE_CLEAN);
			if (preg_match ("/win/i", $OS) ) {
				$imgFile = str_replace ("'", '"', $imgFile);
				$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'mogrify" -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' -crop ' . $new_w . 'x' . $new_h . '+' . $clip_left . '+' . $clip_top . ' ' . str_replace (_OPN_SLASH, '/', $imgFile);
				exec ('"' . $cmd . '"', $output, $retval);
			} else {
				$cmd = $opnConfig['mediagallery_impath'] . 'mogrify -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' -crop \'' . $new_w . 'x' . $new_h . ' +' . $clip_left . ' +' . $clip_top . '\' ' . $imgFile . ' 2>&1';
				exec ($cmd, $output, $retval);
			}
			if ($retval != 0) {
				$this->_setError ($output);
				return false;
			}
			// Call the constructor again to repopulate the dimensions etc
			$this->PerformParams ($this->_directory, $this->_filename);

		}

		/**
		* Resize an image
		*
		* @param int	$new_w	new width
		* @param int	$new_h	new height
		*/

		function resizeImage ($new_w = 0, $new_h = 0) {

			global $opnConfig;

			$imgFile = $this->_escapedname;
			$output = array ();
			$retval = 0;
			$OS='';
			get_var ('OS',$OS,'env',_OOBJ_DTYPE_CLEAN);
			if (preg_match ("/win/i", $OS) ) {
				$imgFile = str_replace ("'", '"', $imgFile);
				$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'mogrify" -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' -geometry ' . $new_w . 'x' . $new_h . ' ' . str_replace (_OPN_SLASH, '/', $imgFile);
				exec ('"' . $cmd . '"', $output, $retval);
			} else {
				$cmd = $opnConfig['mediagallery_impath'] . 'mogrify -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' -geometry \'' . $new_w . 'x' . $new_h . '\' ' . $imgFile . ' 2>&1';
				exec ($cmd, $output, $retval);
			}
			if ($retval != 0) {
				$this->_setError ($output);
				return false;
			}
			// Call the constructor again to repopulate the dimensions etc
			$this->PerformParams ($this->_directory, $this->_filename);

		}

		/**
		* Rotate an image
		*
		* @param $angle
		*/

		function rotateImage (&$angle) {

			global $opnConfig;

			$imgFile = $this->_escapedname;
			$output = array ();
			$OS='';
			$retval = 0;
			get_var ('OS',$OS,'env',_OOBJ_DTYPE_CLEAN);
			if (preg_match ("/win/i", $OS) ) {
				$imgFile = str_replace ("'", '"', $imgFile);
				$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'mogrify" -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' -rotate ' . $angle . str_replace (_OPN_SLASH, '/', $imgFile);
				exec ('"' . $cmd . '"', $output, $retval);
			} else {
				$cmd = $opnConfig['mediagallery_impath'] . 'mogrify -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' -rotate \'' . $angle . '\' ' . $imgFile . ' 2>&1';
				exec ($cmd, $output, $retval);
			}
			if ($retval != 0) {
				$this->_setError ($output);
				return false;
			}
			// Call the constructor again to repopulate the dimensions etc
			$this->PerformParams ($this->_directory, $this->_filename);

		}

		/**
		 * Mirror an image horizontal, vertical or both
		 * 		
		 * @param $type
		 */
		function mirrorImage ($type) {

			global $opnConfig;

			$imgFile = $this->_escapedname;
			$output = array ();
			$OS='';
			$retval = 0;
			get_var ('OS',$OS,'env',_OOBJ_DTYPE_CLEAN);
			switch ($type) {
				case _MIRROR_FLOP:
					$option = ' -flop ';
					break;
				case _MIRROR_FLIP:
					$option = ' -flip ';
					break;
				case _MIRROR_FLIPFLOP:
					$option = ' -flip -flop ';
					break;
			} /* switch */
			if (preg_match ("/win/i", $OS) ) {
				$imgFile = str_replace ("'", '"', $imgFile);
				$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'mogrify" -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . $option . str_replace (_OPN_SLASH, '/', $imgFile);
				exec ('"' . $cmd . '"', $output, $retval);
			} else {
				$cmd = $opnConfig['mediagallery_impath'] . 'mogrify -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . $option . $imgFile . ' 2>&1';
				exec ($cmd, $output, $retval);
			}
			if ($retval != 0) {
				$this->_setError ($output);
				return false;
			}
			// Call the constructor again to repopulate the dimensions etc
			$this->PerformParams ($this->_directory, $this->_filename);
		}

		/**
		* Get the imageinfo array
		*
		* @param $filename
		* @return mixed bool or array
		*/

		function GetImageInfo ($filename) {

			global $opnConfig;

			$output = array ();
			$retval = 0;
			$imgFile = escapeshellarg ($filename);
			$OS='';
			get_var ('OS',$OS,'env',_OOBJ_DTYPE_CLEAN);
			if ($this->_get_scenes ($imgFile) > 1) {
				$imginfo = $this->_get_animated_dimension ($imgFile);
			} else {
				if (preg_match ("/win/i", $OS) ) {
					$imgFile = str_replace ("'", '"', $imgFile);
					$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'identify" -format "%wx%h" ' . str_replace (_OPN_SLASH, '/', $imgFile);
					exec ('"' . $cmd . '"', $output, $retval);
				} else {
					$cmd = $opnConfig['mediagallery_impath'] . 'identify -format \'%wx%h\' ' . $imgFile . ' 2>&1';
					exec ($cmd, $output, $retval);
				}
				if ($retval != 0) {
					$this->_setError ($output);
					return false;
				}
				$imginfo = explode ('x', $output[0]);
				$imginfo[3] = 'height="' . $imginfo[1] . '" width="' . $imginfo[0] . '"';
				$output = array ();
				$retval = 0;
				if (preg_match ("/win/i", $OS) ) {
					$imgFile = str_replace ("'", '"', $imgFile);
					$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'identify" -format "%m" ' . str_replace (_OPN_SLASH, '/', $imgFile);
					exec ('"' . $cmd . '"', $output, $retval);
				} else {
					$cmd = $opnConfig['mediagallery_impath'] . 'identify -format \'%m\' ' . $imgFile . ' 2>&1';
					exec ($cmd, $output, $retval);
				}
				if ($retval != 0) {
					$this->_setError ($output);
					return false;
				}
				if ($output[0] == 'JPEG') {
					$imginfo[2] = IMAGETYPE_JPEG;
				} else {
					$imginfo[2] = $output[0];
				}
				if ($output[0] == 'SVG') {
					$imginfo[0] += 1;
					$imginfo[1] += 1;
				}
			}
			return $imginfo;

		}

		/**
		* Creates a thumbnail for the image
		*
		* @param $filename
		* @param $thumbname
		* @param $width
		* @param $height
		* @param $docheck
		* @return bool
		*/
		function CreateThumbnail ($filename, $thumbname, $width, $height, $docheck = false) {

			global $opnConfig;

			$output = array ();
			$retval = 0;
			$imgFile = escapeshellarg ($filename);
			$thumbFile = escapeshellarg ($thumbname);
			$OS='';
			get_var ('OS',$OS,'env',_OOBJ_DTYPE_CLEAN);
			$prop = '';
			if (!$this->_prop_resize) {
				$prop = '!';
			} else {
				if ($docheck) {
					$imginfo = $this->GetImageInfo ($filename);
					$w = $imginfo[0];
					$h = $imginfo[1];
					$ratioh = $h / $w;
					$ratiow = $w / $h;
					if ($w < $h) {
						$height = ceil ($width * $ratioh);
					} elseif ($h < $w) {
						$width = ceil ($height * $ratiow);
					}
				}
			}
			$commando = $width . 'x' . $height;
			$prop .= '>';
			if (preg_match ("/win/i", $OS) ) {
				$imgFile = str_replace ("'", '"', $imgFile);
				$thumbFile = str_replace ("'", '"', $thumbFile);
				$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'convert" -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' -resize "' . $commando . $prop . '" ' . str_replace (_OPN_SLASH, '/', $imgFile) . ' ' . str_replace (_OPN_SLASH, '/', $thumbFile);
				exec ('"' . $cmd . '"', $output, $retval);
			} else {
				$cmd = $opnConfig['mediagallery_impath'] . 'convert -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' -resize \'' . $commando . $prop . '\' ' . $imgFile . ' ' . $thumbFile . ' 2>&1';
				exec ($cmd, $output, $retval);
			}
			if ($retval != 0) {
				$this->_setError ($output);
				return false;
			}
			$scenes = $this->_get_scenes ($imgFile);
			if ($scenes > 1) {
				$file =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile ();
				if (file_exists ($thumbname)) {
					$file->delete_File ($thumbname);
				}
				$scene0 = $this->_get_scene_filename ($thumbname, 0);
				$file->rename_file($scene0, $thumbname, '0666');
				for ($i = 1; $i < $scenes; $i++) {
					$scene = $this->_get_scene_filename ($thumbname, $i);
					$file->delete_File ($scene);
				}
				unset($file);
			}
			return true;

		}

		/**
		* Converts an image to a another format (normaly JPG).
		*
		* @param $filename
		* @param $convertname
		* @return bool
		*/

		function ConvertImage ($filename, $convertname) {

			global $opnConfig;

			$output = array ();
			$retval = 0;
			$imgFile = escapeshellarg ($filename);
			$convertFile = escapeshellarg ($convertname);
			$OS='';
			get_var ('OS',$OS,'env',_OOBJ_DTYPE_CLEAN);
			if (preg_match ("/win/i", $OS) ) {
				$imgFile = str_replace ("'", '"', $imgFile);
				$convertFile = str_replace ("'", '"', $convertFile);
				$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'convert" -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' ' . str_replace (_OPN_SLASH, '/', $imgFile) . ' ' . str_replace (_OPN_SLASH, '/', $convertname);
				exec ('"' . $cmd . '"', $output, $retval);
			} else {
				$cmd = $opnConfig['mediagallery_impath'] . 'convert -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' ' . $imgFile . ' ' . $convertname . ' 2>&1';
				exec ($cmd, $output, $retval);
			}
			if ($retval != 0) {
				$this->_setError ($output);
				return false;
			}
			return true;

		}

		/**
		 * Size an image
		 * 		
		 * @param $width
		 * @param $height
		 * @return boolean
		 */
		function SizeImage ($width, $heigth) {

			global $opnConfig;

			$imgFile = $this->_escapedname;
			$output = array ();
			$OS='';
			$retval = 0;
			get_var ('OS',$OS,'env',_OOBJ_DTYPE_CLEAN);
			if (preg_match ("/win/i", $OS) ) {
				$imgFile = str_replace ("'", '"', $imgFile);
				$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'mogrify" -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' -geometry ' . $width . 'x' . $heigth . ' ' . str_replace (_OPN_SLASH, '/', $imgFile);
				exec ('"' . $cmd . '"', $output, $retval);
			} else {
				$cmd = $opnConfig['mediagallery_impath'] . 'mogrify -quality ' . $this->_quality . ' ' . $opnConfig['mediagallery_imoptions'] . ' -geometry \'' . $width . 'x' . $heigth . '\' ' . $imgFile . ' 2>&1';
				exec ($cmd, $output, $retval);
			}
			if ($retval != 0) {
				$this->_setError ($output);
				return false;
			}
			return true;
		}

		// private functions

		function _setError ($errors) {

			foreach ($errors as $line) {
				$this->_message .= $line . '<br />';
			}

		}

		/**
		 * Returns the Scenenumbers of a mediafile
		 * 		
		 * @param $imgFile
		 * @return mixed int or boolean
		 */
		function _get_scenes ($imgFile) {

			global $opnConfig;

			$output = array ();
			$retval = 0;
			$OS='';
			get_var ('OS',$OS,'env',_OOBJ_DTYPE_CLEAN);
			if (preg_match ("/win/i", $OS) ) {
				$imgFile = str_replace ("'", '"', $imgFile);
				$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'identify" -format "%n" ' . str_replace (_OPN_SLASH, '/', $imgFile);
				exec ('"' . $cmd . '"', $output, $retval);
			} else {
				$cmd = $opnConfig['mediagallery_impath'] . 'identify -format \'%n\' ' . $imgFile . ' 2>&1';
				exec ($cmd, $output, $retval);
			}
			if ($retval != 0) {
				$this->_setError ($output);
				return false;
			}
			return $output[0];

		}

		/**
		 * Returns the max. width and height for a mediafile with more than one image
		 * 		
		 * @param $imgFile
		 * @return mixed boolean or array
		 */
		function _get_animated_dimension ($imgFile) {

			global $opnConfig;

			$output = array ();
			$retval = 0;
			$OS='';
			get_var ('OS',$OS,'env',_OOBJ_DTYPE_CLEAN);
			if (preg_match ("/win/i", $OS) ) {
				$imgFile = str_replace ("'", '"', $imgFile);
				$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'identify" -format "%wx%h%%" ' . str_replace (_OPN_SLASH, '/', $imgFile);
				exec ('"' . $cmd . '"', $output, $retval);
			} else {
				$cmd = $opnConfig['mediagallery_impath'] . 'identify -format \'%wx%h%%\' ' . $imgFile . ' 2>&1';
				exec ($cmd, $output, $retval);
			}
			if ($retval != 0) {
				$this->_setError ($output);
				return false;
			}
			$vals = explode ('%', $output[0]);
			unset($vals[count ($vals) - 1]);
			$imginfo = array ();
			$imginfo[0] = 0;
			$imginfo[1] = 0;
			foreach ($vals as $val) {
				$img = explode ('x', $val);
				$imginfo[0] = max ($imginfo[0], $img[0]);
				$imginfo[1] = max ($imginfo[1], $img[1]);
			}
			$imginfo[3] = 'height="' . $imginfo[1] . '" width="' . $imginfo[0] . '"';
			$output = array ();
			$retval = 0;
			if (preg_match ("/win/i", $OS) ) {
				$imgFile = str_replace ("'", '"', $imgFile);
				$cmd = '"' . str_replace (_OPN_SLASH, '/', $opnConfig['mediagallery_impath']) . 'identify" -format "%m%%" ' . str_replace (_OPN_SLASH, '/', $imgFile);
				exec ('"' . $cmd . '"', $output, $retval);
			} else {
				$cmd = $opnConfig['mediagallery_impath'] . 'identify -format \'%m%%\' ' . $imgFile . ' 2>&1';
				exec ($cmd, $output, $retval);
			}
			if ($retval != 0) {
				$this->_setError ($output);
				return false;
			}
			$vals = explode ('%', $output[0]);
			if ($vals[0] == 'JPEG') {
				$imginfo[2] = IMAGETYPE_JPEG;
			} else {
				$imginfo[2] = $vals[0];
			}
			unset($vals);
			unset($output);
			return $imginfo;
		}

	}
}

?>