<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MEDIAGALLERY_MEDIAFUNCTIONS_INCLUDED') ) {
	define ('_OPN_MEDIAGALLERY_MEDIAFUNCTIONS_INCLUDED', 1);

	class MediaFunctions {

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_filetypes = array ();
		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_filetypescomplete = array ();

		/**
		 * Class constructor
		 * 		
		 */
		function /*<{4php5}>MediaFunctions!!__construct<{4php5/}>*//*<{delete}>*/MediaFunctions/*<{delete/}>*/ () {

			global $opnConfig, $opnTables;

			$result = $opnConfig['database']->Execute ('SELECT extension, mime, content, icon, player FROM ' . $opnTables['mediagallery_filetypes'] . ' WHERE allowed = 1');
			while (! $result->EOF) {
				$ext = $result->fields['extension'];
				$this->_filetypes[$ext]['mime'] = $result->fields['mime'];
				$this->_filetypes[$ext]['content'] = $result->fields['content'];
				$this->_filetypes[$ext]['icon'] = $result->fields['icon'];
				$this->_filetypes[$ext]['player'] = $result->fields['player'];
				$result->MoveNext ();
			}
			$result->Close ();
			$result = $opnConfig['database']->Execute ('SELECT extension, mime, content, icon, player FROM ' . $opnTables['mediagallery_filetypes']);
			while (! $result->EOF) {
				$ext = $result->fields['extension'];
				$this->_filetypescomplete[$ext]['mime'] = $result->fields['mime'];
				$this->_filetypescomplete[$ext]['content'] = $result->fields['content'];
				$this->_filetypescomplete[$ext]['icon'] = $result->fields['icon'];
				$this->_filetypescomplete[$ext]['player'] = $result->fields['player'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		/**
		* Returns true if the mediafile is allowed to upload.
		*
		* @param $filename
		* @param $filter
		* @return bool
		*/

		function get_type ($filename, $filter = null) {
			if (!is_array ($filename) ) {
				$filename = explode ('.', $filename);
			}
			$index = count ($filename)-1;
			$filename[$index] = strtolower ($filename[$index]);
			if (!isset ($this->_filetypes[$filename[$index]]) ) {
				return false;
			}
			if (!is_null ($filter) && $this->_filetypes[$filename[$index]]['content'] == $filter) {
				return true;
			}
			if (is_null ($filter) ) {
				return true;
			}
			return false;

		}

		/**
		* Returns true if the mediafile is allowed to upload.
		*
		* @param $filename
		* @param $filter
		* @return bool
		*/

		function get_type_all ($filename, $filter = null) {
			if (!is_array ($filename) ) {
				$filename = explode ('.', $filename);
			}
			$index = count ($filename)-1;
			$filename[$index] = strtolower ($filename[$index]);
			if (!isset ($this->_filetypescomplete[$filename[$index]]) ) {
				return false;
			}
			if (!is_null ($filter) && $this->_filetypescomplete[$filename[$index]]['content'] == $filter) {
				return true;
			}
			if (is_null ($filter) ) {
				return true;
			}
			return false;

		}

		/**
		* Returns true if the mediafile is an imagefile.
		*
		* @param $file
		* @return bool
		*/

		function is_image ($file, $all =false) {
			if (!$all) {
				return $this->get_type ($file, 'image');
			}
			return $this->get_type_all ($file, 'image');

		}

		/**
		 * Return true if the mediafile a convertable image
		 * 		
		 * @param $file
		 * @return boolean
		 */
		function is_convertable ($file, $all=false) {

			global $opnConfig;

			if ($opnConfig['mediagallery_libtype'] == 0) {
				$ext = explode ('.', $file);
				$index = count ($ext)-1;
				$ext = strtolower ($ext[$index]);
				if ( ($ext == 'gif') || ($ext == 'png') || ($ext == 'jpg')) {
					return true;
				}
				return false;
			}
			return $this->is_image ($file, $all);

		}

		/**
		 * Return true if the image is a gif, jpg or png
		 * 		
		 * @param $file
		 * @return boolean
		 */
		function is_browser_image ($file) {

			$ext = explode ('.', $file);
			$index = count ($ext)-1;
			$ext = strtolower ($ext[$index]);
			if ( ($ext == 'gif') || ($ext == 'png') || ($ext == 'jpg')) {
				return true;
			}
			return false;

		}

		/**
		 * Convert a filename to a JPG filename
		 * 		
		 * @param $file
		 * @return string
		 */
		function Convert_To_JPG ($file) {

			$ext = explode ('.', $file);
			$ext[count ($ext) - 1] = 'jpg';
			$file = implode ('.', $ext);
			return $file;

		}

		/**
		* Returns true if the mediafile is a moviefile.
		*
		* @param $file
		* @return bool
		*/

		function is_movie ($file, $all=false) {
			if (!$all) {
				return $this->get_type ($file, 'movie');
			}
			return $this->get_type_all ($file, 'movie');

		}

		/**
		* Returns true if the mediafile is an audiofile.
		*
		* @param $file
		* @return bool
		*/

		function is_audio ($file, $all=false) {
			if (!$all) {
				return $this->get_type ($file, 'audio');
			}
			return $this->get_type_all ($file, 'audio');

		}

		/**
		* Returns true if the mediafile is a documentfile.
		*
		* @param $file
		* @return bool
		*/

		function is_document ($file, $all=false) {
			if (!$all) {
				return $this->get_type ($file, 'document');
			}
			return $this->get_type_all ($file, 'document');

		}

		/**
		* Returns true if the mediafile is a known filetype.
		*
		* @param $file
		* @return bool
		*/

		function is_known_filetype ($file, $all = false) {
			return $this->is_image ($file, $all) || $this->is_movie ($file, $all) || $this->is_audio ($file, $all) || $this->is_document ($file, $all);

		}

		/**
		* Returns the icon for the filetype.
		*
		* @param $filename
		* @return string
		*/

		function GetDocumentIcon ($filename) {
			if (!is_array ($filename) ) {
				if ($filename == '') {
					return '';
				}
				$filename = explode ('.', $filename);
			}
			if ((!count ($filename)) || (count ($filename) == 1)) {
				return '';
			}
			$index = count ($filename)-1;
			$filename[$index] = strtolower ($filename[$index]);
			return $this->_filetypescomplete[$filename[$index]]['icon'];

		}

		/**
		* Returns the mimetype for the filetype
		*
		* @param $filename
		* @return string
		*/

		function GetMimetype ($filename) {
			if (!is_array ($filename) ) {
				$filename = explode ('.', $filename);
			}
			$index = count ($filename)-1;
			$filename[$index] = strtolower ($filename[$index]);
			return $this->_filetypescomplete[$filename[$index]]['mime'];

		}

		/**
		 * Return true if the image is a svg
		 * 		
		 * @param $filename
		 * @return boolean
		 */
		function is_svg ($filename) {

			if (!is_array ($filename) ) {
				$filename = explode ('.', $filename);
			}
			$index = count ($filename)-1;
			if (strtolower ($filename[$index]) == 'svg') {
				return true;
			}
			return false;
		}

		/**
		 * Return true if the image is a jpg or png
		 * 
		 * @param $filename
		 * @return boolean
		 */
		function is_jpg_or_png ($filename) {

			if (!is_array ($filename) ) {
				$filename = explode ('.', $filename);
			}
			$index = count ($filename)-1;
			if ((strtolower ($filename[$index]) == 'jpg') || (strtolower ($filename[$index]) == 'png')) {
				return true;
			}
			return false;

		}

		/**
		 * Returns the player
		 * 
		 * @param $filename
		 * @return string
		 */
		function GetPlayer ($filename) {

			if (!is_array ($filename) ) {
				$filename = explode ('.', $filename);
			}
			$index = count ($filename)-1;
			$filename[$index] = strtolower ($filename[$index]);
			return $this->_filetypescomplete[$filename[$index]]['player'];

		}

		/**
		* Returns the allowed extensions.
		*
		* @return array
		*/

		function GetExtensions () {
			return array_keys ($this->_filetypes);

		}
	}
}

?>