<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

/*
* Makros:
*
* class OPN_MACRO_XL_[makroname]
*
* 	function parse (&$text) {
*    			...
* 	}
*
* }
*
*/

include_once (_OPN_ROOT_PATH . 'modules/mediagallery/include/class.filefunctions.php');
include_once (_OPN_ROOT_PATH . 'modules/mediagallery/include/class.mediafunctions.php');

class OPN_MACRO_XL_modul_mediagallery {
	var $replace = array();
	var $search = array();
	var $_filefunction;
	var $_mediafunction;
	var $_images = array();

	function /*<{4php5}>OPN_MACRO_XL_modul_mediagallery!!__construct<{4php5/}>*//*<{delete}>*/OPN_MACRO_XL_modul_mediagallery/*<{delete/}>*/ () {

		global $opnConfig;
		getLanguageDef (_OPN_ROOT_PATH . 'modules/mediagallery/plugin/macros/language/');
		$this->search[] = '#\[gallimage=(.*?)\](.*?)#sie';
		$this->search[] = '#\[gallthumb=(.*?)\](.*?)#sie';
		$this->replace[] = '$this->BuildLink ( \'\\1\');';
		$this->replace[] = '$this->BuildThumb ( \'\\1\');';
		$this->_mediafunction =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ MediaFunctions ();
		$this->_filefunction =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ FileFunctions;
		$opnConfig['module']->InitModule ('modules/mediagallery');
	}

	function BuildLink ($linkid) {

		global $opnConfig, $opnTables;

		$css = 'opn' . $opnConfig['opnOutput']->GetDisplaySide () . 'box';
		if (!isset($this->_images[(int)$linkid])) {
			$result = $opnConfig['database']->Execute ('SELECT filename, title FROM ' . $opnTables['mediagallery_pictures'] . ' WHERE pid=' . (int)$linkid);
			$this->_images[(int)$linkid]['filename'] = $result->fields['filename'];
			$this->_images[(int)$linkid]['title'] = $result->fields['title'];
			$result->Close ();
		}
		if ($this->_mediafunction->is_convertable ($this->_images[(int)$linkid]['filename'], true)) {
			$url = encodeurl (array ($opnConfig['opn_url'] . '/modules/mediagallery/index.php',
										'op' => 'fullsize',
										'media' => $linkid) );
			$image = $this->_filefunction->GetThumbnailName ($this->_images[(int)$linkid]['filename'], (int)$linkid, _PATH_MEDIA, _THUMB_NORMAL, true);
			$link = '<a class="' . $css . '" href="' . $url . '" target="_blank"><img src="' . $image . '" alt="' . $this->_images[(int)$linkid]['title'] . '" title="' . $this->_images[(int)$linkid]['title'] . '" /></a>';
		} else {
			$url = encodeurl (array ($opnConfig['opn_url'] . '/modules/mediagallery/index.php',
										'op' => 'viewmedia',
										'offset' => -$linkid) );
			$link = '<a class="' . $css . '" href="' . $url . '">' . _MEDIAGALLERY_MACRO_TEXT . ' ' . $this->_images[(int)$linkid]['title'] . '</a>';
		}
		return $link;

	}

	function BuildThumb ($linkid) {

		global $opnConfig, $opnTables;

		$css = 'opn' . $opnConfig['opnOutput']->GetDisplaySide () . 'box';
		if (!isset($this->_images[(int)$linkid])) {
			$result = $opnConfig['database']->Execute ('SELECT filename, title FROM ' . $opnTables['mediagallery_pictures'] . ' WHERE pid=' . (int)$linkid);
			$this->_images[(int)$linkid]['filename'] = $result->fields['filename'];
			$this->_images[(int)$linkid]['title'] = $result->fields['title'];
			$result->Close ();
		}
		$url = encodeurl (array ($opnConfig['opn_url'] . '/modules/mediagallery/index.php',
									'op' => 'fullsize',
									'media' => $linkid) );
		if ($this->_mediafunction->is_convertable ($this->_images[(int)$linkid]['filename'], true)) {
			$image = $this->_filefunction->GetThumbnailName ($this->_images[(int)$linkid]['filename'], (int)$linkid, _PATH_MEDIA, _THUMB_THUMB, $this->_filefunction, true);
		} else {
			$image = $opnConfig['datasave']['mediagallery_images']['url'] . '/filetypes/' . $this->_mediafunction->GetDocumentIcon ($this->_images[(int)$linkid]['filename']);
		}
		return '<a class="' . $css . '" href="' . $url . '" target="_blank"><img src="' . $image . '" alt="' . $this->_images[(int)$linkid]['title'] . '" title="' . $this->_images[(int)$linkid]['title'] . '" /></a>';

	}

	function parse (&$text) {

		$haslinks = false;
		$hasselect = false;
		$hasscript = false;
		$hastitle = false;
		$hasimg = false;
		if ( (substr_count (strtolower($text), '<a ')>0)) {
			$haslinks = true;
			replace_tag ($text, 'a', $links = array () );
		}
		if ( (substr_count (strtolower($text), '<select ')>0)) {
			$hasselect = true;
			replace_tag ($text, 'select', $selects = array () );
		}
		if ( (substr_count (strtolower($text), '<script')>0)) {
			$hasscript = true;
			$scripts = array ();
			replace_tag ($text, 'script', $scripts);
		}
		if ( (substr_count (strtolower($text), '<img')>0)) {
			$hasimg = true;
			$images = array ();
			replace_tag ($text, 'img', $images);
		}
		if ( (substr_count (strtolower($text), 'title="')>0)) {
			$hastitle = true;
			$titles = array ();
			replace_attribute ($text, 'title', $titles);
		}
		$text = preg_replace ($this->search, $this->replace, $text);
		if ($haslinks) {
			restore_tag ($text, 'a', $links);
			unset ($links);
		}
		if ($hasselect) {
			restore_tag ($text, 'select', $selects);
			unset ($selects);
		}
		if ($hasscript) {
			restore_tag ($text, 'script', $scripts);
			unset ($scripts);
		}
		if ($hasimg) {
			restore_tag ($text, 'img', $images);
			unset ($images);
		}
		if ($hastitle) {
			restore_attribute ($text, 'title', $titles);
			unset ($titles);
		}

	}

}

?>